package com.yc.ship.module.resource.service.guidegroup;

import com.yc.ship.framework.common.pojo.PageResult;
import com.yc.ship.module.resource.controller.admin.guidegroup.vo.GuideGroupPageReqVO;
import com.yc.ship.module.resource.controller.admin.guidegroup.vo.GuideGroupSaveReqVO;
import com.yc.ship.module.resource.controller.admin.vo.SimpleListReqVO;
import com.yc.ship.module.resource.dal.dataobject.guidegroup.GuideGroupDO;

import javax.validation.Valid;
import java.util.List;

/**
 * 导游分组 Service 接口
 *
 * @author 管理员
 */
public interface GuideGroupService {

    /**
     * 创建导游分组
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    String createGuideGroup(@Valid GuideGroupSaveReqVO createReqVO);

    /**
     * 更新导游分组
     *
     * @param updateReqVO 更新信息
     */
    void updateGuideGroup(@Valid GuideGroupSaveReqVO updateReqVO);

    /**
     * 删除导游分组
     *
     * @param id 编号
     */
    void deleteGuideGroup(String id);

    /**
     * 获得导游分组
     *
     * @param id 编号
     * @return 导游分组
     */
    GuideGroupDO getGuideGroup(String id);

    /**
     * 获得导游分组分页
     *
     * @param pageReqVO 分页查询
     * @return 导游分组分页
     */
    PageResult<GuideGroupDO> getGuideGroupPage(GuideGroupPageReqVO pageReqVO);

    List<GuideGroupDO> getGroupList(SimpleListReqVO listReqVO);

    List<String> getGroupAndAllChildren(String id);
}
